import java.awt.*;
import java.awt.event.*;

public class CommunicationWindow extends Frame
{
  public static final int FrameWidth  = 400;
  public static final int FrameHeight = 400;

  private CommunicationWindow partner;
  private String              name;
  private String              message;
  private int                 buttonPressCount;

  public CommunicationWindow( String windowName )
  {
    setSize ( FrameWidth, FrameHeight );
    setTitle( "CommunicationWindow " + windowName );

    Button fire = new Button( "Go!" );
    fire.addActionListener( new GoButtonListener() );
    add( "North", fire );

    name             = windowName;
    partner          = null;
    message          = "I am " + name + "!";
    buttonPressCount = 0;
  }

  public void writeTo( CommunicationWindow w )
  {
    partner = w;
  }

  public void write( String newMessage )
  {
    message = newMessage;
    repaint();
  }
  
  public void paint (Graphics g)
  {
    g.drawString( message, 50, FrameHeight/2);
  }

  private class GoButtonListener implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      buttonPressCount++;
      if ( partner != null )
        partner.write( "Someone pressed "   + name             +
                       "'s button for the " + buttonPressCount +
                       "th time!" );
    }
  }
}
